### raw data
class HybridPipe(Pipeline):
    def __init__(...):
        #define pipeline operations
        self.input = ops.FileReader(...)
        self.decode = ops.ImageDecoder(device='mixed', ...)
        self.res = ops.RandomResizedCrop(device='gpu', ...)
        ...
        
    def define_graph(self):
        #define pipeline graph
        self.jpegs, self.labels = self.input()
        images = self.decode(self.jpegs)
        images = self.res(images)
        ...
        return [images, self.labels]
        
### record file
class HybridPipe(Pipeline):
    def __init__(...):
        #define pipeline operations
        self.input = ops.TFRecordReader(path,index_path,features)
        ...
        
    def define_graph(self):
        #define pipeline graph
        input = self.input()
        self.jpegs = input["image"]
        self.labels = input["label"]
        ...
        return [images, self.labels]